unit Barcode;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Thubar39, ExtCtrls, StdCtrls, Buttons;

type
  TfBarCode = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    pdBarCode: TPrintDialog;
    lbWBarCode: TListBox;
    sbAdd: TSpeedButton;
    sbDel: TSpeedButton;
    sbAddAll: TSpeedButton;
    sbNew: TSpeedButton;
    lbBarCode: TListBox;
    Label3: TLabel;
    eWBarCode: TEdit;
    Label4: TLabel;
    eBarCode: TEdit;
    bbPrint: TBitBtn;
    bbClose: TBitBtn;
    Panel1: TPanel;
    HUBarcode391: THUBarcode39;
    Label5: TLabel;
    Label6: TLabel;
    procedure bbPrintClick(Sender: TObject);
    procedure bbCloseClick(Sender: TObject);
    procedure sbAddClick(Sender: TObject);
    procedure sbAddAllClick(Sender: TObject);
    procedure sbDelClick(Sender: TObject);
    procedure sbNewClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
procedure MyReadBar(var tsTemp:TStrings);
  public
    { Public declarations }
  end;

var
  fBarCode: TfBarCode;

implementation

{$R *.DFM}
Uses
   Printers;
Type
   BarType = Array[1..30] of THUBarcode39;
Var
   Bar39 : BarType;
   i     : Byte;
  PNum   : Byte;

procedure TfBarCode.bbPrintClick(Sender: TObject);
begin
 If lbBarCode.Items.Count <= 0 then Exit;
 If lbBarCode.Items.Count > 30 then PNum := 30
  else PNum := lbBarCode.Items.Count;

 For i := 1 to PNum do
   Begin
     Bar39[i] := THUBarcode39.Create(fBarCode);
     Bar39[i].Parent := Panel1;
     Bar39[i].BarStr := lbBarCode.Items[i-1];
     Bar39[i].BarCodeHeight := bheight5;
     Bar39[i].PrintRate := PR4;
     Bar39[i].Font.Size := 12;
     Bar39[i].HeadStr := '';
     Bar39[i].Top:=HUBarcode391.Top;
     Bar39[i].Left:=HUBarcode391.Left;
   End;

 If pdBarCode.Execute then
  With Printer do
   Begin
     BeginDoc;
    For i := 1 to PNum do
      Begin

        Canvas.Draw(((i-1) mod 3)*670+50,((i-1) div 3)*310,Bar39[i].Picture.Graphic);

      End;
     EndDoc;
   End;

 For i := 1 to PNum do
   Bar39[i].Free;


end;

procedure TfBarCode.bbCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfBarCode.sbAddClick(Sender: TObject);
{ W[CLX}
Var
  i  : Word;
begin
  i := lbWBarCode.Items.Count;
 If lbWBarCode.SelCount <> 0 then
   While i <> 0 do
     Begin
      If lbWBarCode.Selected[i-1] then
       If lbBarCode.Items.IndexOf(lbWBarCode.Items[i-1]) = -1
         then
          Begin
            lbBarCode.Items.Add(lbWBarCode.Items[i-1]);
            lbWBarCode.Items.Delete(i-1);
          End;
       i := i-1;
     End;
  ewBarCode.Text := IntToStr(lbwBarCode.Items.Count);
  eBarCode.Text := IntToStr(lbBarCode.Items.Count);
end;

procedure TfBarCode.sbAddAllClick(Sender: TObject);
{ W[ҦݦCLXܱCLX}
begin
  lbBarCode.Items.AddStrings(lbWBarCode.Items);
  lbWBarCode.Items.Clear;
  eWBarCode.Text := IntToStr(lbWBarCode.Items.Count);
  eBarCode.Text  := IntToStr(lbBarCode.Items.Count);
end;

procedure TfBarCode.sbDelClick(Sender: TObject);
{ ֱCLX}
begin
  i := lbBarCode.Items.Count;
 If lbBarCode.SelCount > 0 then
   Begin
     While i <> 0 do
       Begin
        If lbBarCode.Selected[i-1] then
          Begin
           If lbWBarCode.Items.IndexOf(lbBarCode.Items[i-1]) = -1
             then lbWBarCode.Items.Add(lbBarCode.Items[i-1]);
            lbBarCode.Items.Delete(i-1);
          End;
         i := i-1;
       End;
   End;
  ewBarCode.Text := IntToStr(lbwBarCode.Items.Count);
  eBarCode.Text := IntToStr(lbBarCode.Items.Count);

end;

procedure TfBarCode.sbNewClick(Sender: TObject);

Var
   sNewTemp  : String;
begin
  sNewTemp := InputBox('۩wX','пJX:','');
 If (lbBarCode.Items.IndexOf(sNewTemp) = -1)
   and (sNewTemp <> '')
  then lbBarCode.Items.Add(sNewTemp);
  eBarCode.Text := IntToStr(lbBarCode.Items.Count);
end;

procedure TfBarCode.FormCreate(Sender: TObject);
var
  tsTemp : TStrings;
begin
  fBarCode.Top:=0;
  fBarCode.Left:=0;
  lbWBarCode.Items.Clear;
  lbBarCode.Items.Clear;
  tsTemp := TStringList.Create;
  MyReadBar(tsTemp);
  lbWBarCode.Items := tsTemp;
  tsTemp.Free;
  eWBarCode.Text := IntToStr(lbWBarCode.Items.Count);
  eBarCode.Text := '0';
  PNum := 0;
end;


procedure TfBarCode.MyReadBar(var tsTemp:TStrings);
var
  i : integer;
begin
  i:=tsTemp.Add('000715');
  i:=tsTemp.Add('0012');
  i:=tsTemp.Add('5621');
  i:=tsTemp.Add('6179');
  i:=tsTemp.Add('830702');
  i:=tsTemp.Add('850809');
  i:=tsTemp.Add('6441');
  i:=tsTemp.Add('840403');
  i:=tsTemp.Add('0148');
  i:=tsTemp.Add('830901');
  i:=tsTemp.Add('840305');
  i:=tsTemp.Add('850402');
  i:=tsTemp.Add('840302');
  i:=tsTemp.Add('850303');
  i:=tsTemp.Add('851103');
  i:=tsTemp.Add('790801');
  i:=tsTemp.Add('791002');
  i:=tsTemp.Add('0219');
  i:=tsTemp.Add('800603');
  i:=tsTemp.Add('800806');
  i:=tsTemp.Add('0604');
  i:=tsTemp.Add('1439');
  i:=tsTemp.Add('800702');
  i:=tsTemp.Add('811203');
  i:=tsTemp.Add('840101');
  i:=tsTemp.Add('840304');
  i:=tsTemp.Add('851004');
  i:=tsTemp.Add('3001');
  i:=tsTemp.Add('0710');
  i:=tsTemp.Add('5561');
end;

end.
